#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include "hardware.h"

int main(int argc, char **argv)
{
int dev,i,b;
char buf[LCD_COLS*LCD_LINES];

  dev=open("/dev/lcd",O_WRONLY|O_NDELAY);
  if (dev==-1) exit(-1);
  buf[0]=27;
  buf[1]='c';
  write(dev,buf,2);
  for (i=1;i<=(LCD_COLS*LCD_LINES);i++) buf[i-1]=(i%10)+48;
  write(dev,buf,LCD_COLS*LCD_LINES);
  printf("You should see numbers in all rows now. (Press any key when ready)\n");
  getchar();

  for (i=0x00;i<(LCD_COLS*LCD_LINES);i++) buf[i]=0x0db;
  for (i=0;i<16;i++) buf[i]=i+0x20;
  for (i=0;i<16;i++) buf[i+LCD_COLS]=i+0x30;
  for (i=0;i<16;i++) buf[i+2*LCD_COLS]=i+0x40;
  for (i=0;i<16;i++) buf[i+3*LCD_COLS]=i+0x50;
  write(dev,buf,LCD_COLS*LCD_LINES);
  printf("You should see the char set now. (Press any key when ready)\n");
  getchar();

  for (i=0;i<16;i++) buf[i]=i+0x60;
  for (i=0;i<16;i++) buf[i+LCD_COLS]=i+0x70;
  for (i=0;i<16;i++) buf[i+2*LCD_COLS]=i+0x0a0;
  for (i=0;i<16;i++) buf[i+3*LCD_COLS]=i+0x0b0;
  write(dev,buf,LCD_COLS*LCD_LINES);
  printf("You should see the char set now. (Press any key when ready)\n");
  getchar();

  for (i=0;i<16;i++) buf[i]=i+0x0c0;
  for (i=0;i<16;i++) buf[i+LCD_COLS]=i+0x0d0;
  for (i=0;i<16;i++) buf[i+2*LCD_COLS]=i+0x0e0;
  for (i=0;i<16;i++) buf[i+3*LCD_COLS]=i+0x0f0;
  write(dev,buf,LCD_COLS*LCD_LINES);
  printf("You should see the char set now. (Press any key when ready)\n");
  getchar();

  printf("And now some screens with the whole font ;) Interrupt to end...\n");
  while(1) {
    for (i=0x00; i<0x10; i++) {     /* loadable characters */
      for (b=0;b<(LCD_COLS*LCD_LINES);b++) buf[b]=i;
/*      sprintf(buf,"%d",i);*/
      write(dev,buf,(LCD_COLS*LCD_LINES));
      usleep(500000);
    }
    for (i=0x20; i<0x80; i++) {
      for (b=0;b<(LCD_COLS*LCD_LINES);b++) buf[b]=i;
/*      sprintf(buf,"%d",i);*/
      write(dev,buf,(LCD_COLS*LCD_LINES));
      usleep(500000);
    }
    for (i=0x0a0; i<0x100; i++) {
      for (b=0;b<(LCD_COLS*LCD_LINES);b++) buf[b]=i;
/*      sprintf(buf,"%d",i);*/
      write(dev,buf,(LCD_COLS*LCD_LINES));
      usleep(500000);
    }
  }
  close(dev);
 
return(0);
}
